package cl.axg.hls_player;

import java.io.UnsupportedEncodingException;
import java.nio.charset.Charset;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
class EPG{
    private String titulo;
    private long horaInicio;
    private long horaFin;
    private int duracion;
    private String siguiente;
    private String anterior;


   public EPG( String titulo, String horaInicio,  String horaFin, String duracion,String anterior, String siguiente){
       this.titulo = titulo;
       this.horaInicio = Long.parseLong(horaInicio);
        this.horaFin =  Long.parseLong(horaFin);
        this.duracion = Integer.parseInt(duracion);
       this.anterior = anterior;
       this.siguiente = siguiente;
    }

    public String getTitulo(){
        try {
            byte[]    response = this.titulo.getBytes(Charset.forName("ISO-8859-1"));
            this.titulo = new String(response, "ISO-8859-1");
        } catch (UnsupportedEncodingException e) {
            e.printStackTrace();
        }
        return this.titulo.length() <= 0 ? "NO_TITLE" : this.titulo;
    }

    public long getHoraFin(){
        return  this.horaFin ;
    }
     public String getHoraFinFormato(){
         return new java.text.SimpleDateFormat("HH:mm").format(new java.util.Date(Long.parseLong(this.horaFin+ "000") ));
     }
     public long getHoraInicio(){
         return  this.horaInicio ;
     }
     public String getHoraInicioFormato(){
         return new java.text.SimpleDateFormat("HH:mm").format(new java.util.Date(Long.parseLong(this.horaInicio+ "000")) );
   }

     public int getDuracion(){
        return this.duracion;
    }

    public String getSiguiente(){
        return this.siguiente;
    }
    public String getAnterior(){
        return this.anterior;
    }
    public  int getPercentageLeft() throws ParseException {

        long now = System.currentTimeMillis();
        Date fecha_now = new Date(now );

        Date fecha_inicio = new Date(Long.parseLong(this.horaInicio + "000") );
        String fecha_inicio_formato =  new java.text.SimpleDateFormat(" H:m:s").format(fecha_inicio);


        Date fecha_fin =new Date(Long.parseLong(this.horaFin + "000") );
        String fecha_fin_formato =  new java.text.SimpleDateFormat(" H:m:s").format(fecha_fin);

        Date fecha_actual =new Date(System.currentTimeMillis()  );


        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd H:m:s");

        Date fechaInicial=dateFormat.parse(new java.text.SimpleDateFormat("yyyy-MM-dd").format(fecha_actual)+fecha_inicio_formato);
        Date fechaFinal=dateFormat.parse(  new java.text.SimpleDateFormat("yyyy-MM-dd").format(fecha_actual)+fecha_fin_formato);
        Date fecha_now1=dateFormat.parse(  dateFormat.format(fecha_actual));


        //in milliseconds
        long diff = fechaFinal.getTime() - fecha_now1.getTime();

        long diffSeconds = diff / 1000 % 60;
        long diffMinutes = diff / (60 * 1000) % 60;
        long diffHours = diff / (60 * 60 * 1000) % 24;
        long diffDays = diff / (24 * 60 * 60 * 1000);

        System.out.print(diffDays + " days, ");
        System.out.print(diffHours + " hours, ");
        System.out.print(diffMinutes + " minutes, ");
        System.out.print(diffSeconds + " seconds.");

       long now1 = fecha_now1.getTime();
        long s = fechaInicial.getTime();
        long e = fechaFinal.getTime();
        if (s >= e || now1 >= e) {
            return 0;
        }
        if (now1 <= s) {
            return 100;
        }
        return 100 - (int) ((e - now1) * 100 / (e - s));
    }

}
